| GL Studio C++ Runtime API

Classes | Public Types | Public Member Functions | Static Public Attributes | Protected Types | Protected Member Functions | Protected Attributes | Static Protected Attributes | List of all members
GlsText Class Reference

`#include <gls_text.h>`

Inheritance diagram for GlsText:

## Classes
struct | CharAttr_t
| Attributes for each character position in the grid. More...
class | LineSegment_t

## Public Types
enum | { NUM_VERTICES = 4 }
enum | Justify_t { LEFT , CENTER , RIGHT }
| Different text justifications.
typedef GLPolygon | _BaseClass
| Deprecated typedef for the base class.
typedef GLPolygon | BaseClass
| Typedef for the base class.
typedef GlsFontBase::Char_t | Char_t
| Typedef shorthand for GlsFontBase::Char_t.
Public Types inherited from GLPolygon
typedef DisplayObject | _BaseClass
| Deprecated typedef for the base class.
typedef DisplayObject | BaseClass
| Typedef for the base class.
Public Types inherited from DisplayObject
enum | AvailableAttributesEnum { GLS_ATTRIBUTES_BASIC = 1 , GLS_ATTRIBUTES_DYNAMIC = 2 , GLS_ATTRIBUTES_APPEARANCE = 4 , GLS_ATTRIBUTES_GEOMETRY = 8 , GLS_ATTRIBUTES_SPECIALIZED = 16 , GLS_ATTRIBUTES_ALL = ~0 , GLS_ATTRIBUTES_NONE = 0 }

## Public Member Functions
| GlsText ()
| GlsText (const GlsText &that, const bool generateNames)
virtual | ~GlsText ()
virtual void | SetAvailableAttributes (unsigned int value) override
void | Baseline (const float &baselineShift)
float | Baseline ()
void | BgColor (const GlsColor &color)
GlsColor | BgColor ()
void | Border (const float &units)
float | Border () const
void | CellHeight (float height)
float | CellHeight () const
void | CellWidth (float width)
float | CellWidth () const
void | Char (Char_t code)
CharAttr_t | CharAttribs () const
CharAttr_t | CharAttr (unsigned int index) const
void | CharScaling (const float &newScale)
float | CharScaling ()
void | CharSpacing (const float &horizontalSpacing)
float | CharSpacing ()
void | ConstrainCellRatio (bool constrain)
bool | ConstrainCellRatio () const
void | ControlCellSize (bool control)
bool | ControlCellSize () const
virtual void | CopyGeometry (DisplayObject *src) override
virtual void | CopyProperties (DisplayObject *src) override
void | Erase ()
void | FauxBold (const bool &bold)
bool | FauxBold ()
GlsFontBase * | Font () const
void | Font (GlsFontBase *font)
void | Halo (bool halo)
bool | Halo () const
void | HaloColor (const GlsColor &color)
GlsColor | HaloColor () const
void | InvalidateFont ()
void | Inverse (const bool &inverse)
bool | Inverse ()
void | Justify (Justify_t justification)
Justify_t | Justify () const
void | LineSpacing (float spacing)
float | LineSpacing () const
void | LockCellSize (bool lock)
bool | LockCellSize () const
virtual void | Rotate (const Vector &orig, float angle, const Vector &axis) override
virtual void | SetValue (int spec, va_list &args) override
virtual void | SetFromGloData (GlsGloFileAttribute &data) override
void | Shadow (bool shadow)
bool | Shadow () const
void | ShadowColor (const GlsColor &color)
GlsColor | ShadowColor () const
void | ShadowDistance (const float &dist)
void | ShadowOffset (const Vector &offset)
Vector | ShadowOffset ()
void | StrikeThru (const bool &strike)
bool | StrikeThru ()
virtual void | String (const std::string &s)
virtual void | String (const char *s)
std::string | String () const
void | TextColor (const GlsColor &color)
GlsColor | TextColor ()
void | Underline (const bool &underline)
bool | Underline ()
void | Uppercase (bool uppercase)
bool | Uppercase () const
void | WrapText (bool wrap)
bool | WrapText () const
void | SetRebuild ()
virtual bool | RequiresFontFile () const
virtual void | Rotate (float angle, int axis=Z_AXIS)
virtual void | Rotate (const Vector &origin, float angle, int axis=Z_AXIS)
virtual void | Rotate (const Vector &orig, float angle, const Vector &axis)
Public Member Functions inherited from GLPolygon
| GLPolygon (unsigned int nPoints, const Vertex *vertices)
| GLPolygon (unsigned int nPoints, const Vertex *vertices, const Vertex &location)
| GLPolygon ()
| GLPolygon (const GLPolygon &polygon, const bool generateNames)
virtual | ~GLPolygon ()
void | ConfigureMetaData ()
virtual DisplayObject * | CloneObject (bool generateNames=false)
virtual void | PreDraw (const OpenGLMatrices &current, Culler &culler) override
virtual void | Draw () override
virtual void | CalculateTextureCoordinates ()
virtual void | CalcNormals (int windingOrder=1)
virtual void | SetFillColor (unsigned char r, unsigned char g, unsigned char b, unsigned char a)
virtual void | SetFillColor (const GlsColor &color)
virtual void | DeleteVertexAt (unsigned int index)
virtual DisplayObject * | Pick3D (const Vector &winLoc, const Vector &logicalCoords, float scale, const Vector &directionVector, Vector &collisionWinLoc, const OpenGLMatrices &drawnMatrices) override
Public Member Functions inherited from DisplayObject
| DisplayObject (float x, float y, float z)
| DisplayObject (const DisplayObject &object, const bool generateNames)
virtual | ~DisplayObject ()
void | Destroy ()
virtual void | SetAvailableAttributes (unsigned int value)
virtual void | AlphaMode (int mode)
virtual int | AlphaMode ()
virtual bool | AntiAlias ()
virtual void | AntiAlias (bool alias)
void | ApplyTextureSettings (int textureIndex=-1)
DistiAttribDict & | Attributes ()
const DistiAttribDict & | Attributes () const
virtual void | SetBlendColor (const GlsColor &color)
void | GetBlendColor (unsigned char color[])
void | GetBlendColor (unsigned char &r, unsigned char &g, unsigned char &b, unsigned char &a)
virtual GlsColor | GetBlendColor ()
void | SetBlendColor (unsigned char color[])
void | SetBlendColor (unsigned char r, unsigned char g, unsigned char b, unsigned char a)
virtual bool | BlinkedOff ()
virtual bool | Blinking ()
virtual void | Blinking (const bool blink)
virtual float | BlinkRate ()
virtual void | BlinkRate (const float rate)
const Vector & | BoundingVolumeCenter () const
void | BoundingVolumeCenter (const Vector &center)
bool | BoundingVolumeHit (const Vector &start, const Vector &direction)
float | BoundingVolumeRadius () const
void | BoundingVolumeRadius (float radius)
virtual void | Calculate (double time)
void | CalculateCollisionPoint (const Vector &pickLoc, const Vector &directionVector, Vector *collisionPoint)
virtual void | CalculateParentBoundingBox ()
virtual void | CalculateTextureCoordinates ()
bool | GetTexturePointTransformationMatrix (GlsMatrixType &world2tex)
CallbackMethodCallerBase * | CallbackCaller () const
void | CallbackCaller (CallbackMethodCallerBase *cb)
virtual void | GetCenter (Vector &center)
virtual DisplayObject * | CloneObject (bool generateNames=false)=0
virtual GlsColor | GetColor ()
void | GetColor (unsigned char c4[])
void | GetColor (unsigned char &r, unsigned char &g, unsigned char &b, unsigned char &a)
virtual void | SetColor (const GlsColor &color)
void | SetColor (unsigned char c4[])
void | SetColor (unsigned char r, unsigned char g, unsigned char b, unsigned char a)
virtual void | CopyGeometry (DisplayObject *src)
virtual void | CopyHierarchyProperties (DisplayObject *src, bool copyName)
virtual void | CopyProperties (DisplayObject *src)
virtual void | CullBackFace (const bool val)
virtual bool | CullBackFace ()
bool | Culled () const
void | Culled (bool val)
bool | CullTest (const GlsMatrixType *matrix, const Culler &culler)
GlsMatrixType & | DcsMatrix ()
GlsMatrixType | DcsMatrix () const
void | DcsMatrix (const GlsMatrixType &matrix)
virtual void | DeleteVertexAt (unsigned int index)
virtual void | DeleteVertex (unsigned int indexAfter) final
virtual int | DepthTest ()
virtual void | DepthTest (unsigned char zbuf)
virtual void | Draw ()=0
const GlsMatrixType * | DrawMatrix ()
bool | NeedCalcDrawMatrix ()
void | DynamicRotate (float angle, int axis)
void | DynamicRotate (const Vector &v)
void | DynamicRotate (float angle[])
virtual void | DynamicRotate (float x, float y, float z)
virtual void | DynamicRotateRelative (float angle, int axis)
virtual float | DynamicRotation (int axis)
virtual Vector | DynamicRotation ()
virtual Vector | DynamicScale ()
virtual void | DynamicScale (float x, float y, float z)
void | DynamicScale (const Vector &scale)
virtual void | DynamicTranslate (float x, float y, float z, bool relative=false)
void | DynamicTranslate (const Vertex &amount, bool relative)
void | DynamicTranslate (const Vector &amount)
virtual void | DynamicTranslateAxis (float amount, int axis, bool relative)
virtual float | DynamicTranslation (int axis)
virtual Vector | DynamicTranslation ()
DisplayObjectEditor * | Editor ()
const DisplayObjectEditor * | Editor () const
void | Editor (DisplayObjectEditor *editor)
virtual void | GetExtents (float &x, float &y, float &z, float &x1, float &y1, float &z1)
void | GetExtentsDCS (Vector &min, Vector &max)
void | GetFillColor (unsigned char &r, unsigned char &g, unsigned char &b, unsigned char &a)
void | GetFillColor (unsigned char c4[])
virtual GlsColor | GetFillColor ()
void | SetFillColor (unsigned char r, unsigned char g, unsigned char b, unsigned char a)
void | SetFillColor (unsigned char c4[])
virtual void | SetFillColor (const GlsColor &color)
virtual void | FinishObject ()
virtual void | GenerateInstanceName ()
virtual DisplayObject * | handle (DisplayEvent *ev)
virtual bool | Hit (float x, float y, float z, float scale, const Vector &directionVector, Vector *collisionPoint)
virtual bool | HitUtil (float x, float y, float z, float scale, Vertex *vertices, unsigned int vertex_cnt, const Vector &directionVector, Vector *collisionPoint)
virtual void | InsertVertexAt (unsigned int index)
virtual void | InsertVertex (unsigned int indexAfter) final
char * | InstanceName ()
const char * | InstanceName () const
void | InstanceName (const char *name)
virtual bool | LightingEnabled ()
virtual void | LightingEnabled (bool lighting)
virtual int | LineStippleMultiplier ()
virtual void | LineStippleMultiplier (int mult)
virtual int | LineStipplePattern ()
virtual void | LineStipplePattern (int pattern)
virtual float | LineWidth ()
virtual void | LineWidth (float width)
virtual const Vertex & | Location () const
virtual void | Location (const Vertex &v)
virtual void | Location (float x, float y, float z)
virtual void | GetLocation (Vertex &v)
virtual void | GetLocation (float &x, float &y, float &z)
float | X () const
float | Y () const
float | Z () const
void | X (const float x)
void | Y (const float y)
void | Z (const float z)
virtual int | MaterialIndex ()
virtual void | MaterialIndex (int index)
virtual DynamicArray< int > & | MaterialIndices ()
virtual void | MaterialIndices (DynamicArray< int > indices)
GlsMatrixType * | ModelMatrix ()
bool | NeedCalculate ()
Vector * | Normals ()
virtual void | SetNormals (unsigned int nPoints, Vector *vertices)
void | VaSetNormals (unsigned int nPoints,...)
unsigned int | NumberOfVertices () const
virtual float | ObjectDepth ()
virtual float | ObjectHeight ()
virtual float | ObjectWidth ()
virtual void | SetOrigin (const Vertex &vert)
virtual void | Parent (DisplayFrame *par)
DisplayFrame * | Parent () const
virtual void | ParentGroup (Group *group)
Group * | ParentGroup () const
virtual DisplayObject * | Pick3D (const Vector &winLoc, const Vector &logicalCoords, float scale, const Vector &directionVector, Vector &collisionWinLoc, const OpenGLMatrices &drawnMatrices)
unsigned char | Pickable ()
virtual void | Pickable (unsigned char pick)
virtual int | PolygonEnd ()
virtual void | PolygonEnd (const int end)
virtual int | PolygonMode ()
virtual void | PolygonMode (int mode)
virtual void | PreDraw (const OpenGLMatrices &current, Culler &culler)
GlsMatrixType * | ProjMatrix ()
virtual void | ReallocateVertices (unsigned int numVertices, bool initializeNew, bool copyOld)
virtual float | RelativeAngle (const float x, const float y)
virtual DistiAttributeBase & | Resource (const char *name)
virtual void | GetResources (std::ostream &outstr, GlsResourceFilter *filter=NULL)
const Vertex & | RotationPoint () const
virtual void | RotationPoint (const Vertex &v)
virtual void | RotationPoint (float x, float y, float z)
virtual void | GetRotationPoint (Vertex &v)
virtual void | Rotate (float angle, int axis=Z_AXIS)
virtual void | Rotate (const Vector &origin, float angle, int axis=Z_AXIS)
virtual void | Rotate (const Vector &orig, float angle, const Vector &axis)
void | SaveMatrices ()
virtual void | Scale (float px, float py, float pz, Vertex *anchor, int handleBar=0)
void | Set (int spec,...)
bool | SetupAlpha ()
void | SetupDepthTest ()
void | SetupLighting ()
bool | SetupLineStyle ()
bool | SetupTexture ()
virtual int | Shading ()
virtual void | Shading (const int shading)
virtual void | GetTransformedExtents (Vector &min, Vector &max, const GlsMatrixType &matrix, bool resetMinMax=true)
virtual void | SetTexCoords (unsigned int nPoints, Vector *new_tex_coord, bool isVectorArray=true)
void | SetTexCoords (unsigned int nPoints, Vertex *new_tex_coord)
void | VaSetTexCoords (unsigned int nPoints,...)
Vector * | TextureCoordinates ()
Vector * | GetTextureCoordinates ()
virtual int | TextureIndex ()
virtual void | TextureIndex (int textureIndex)
virtual Vector * | GetTexturePoints ()
virtual bool | TextureRepeat ()
virtual void | TextureRepeat (const int rep)
virtual int | TextureMappingTechnique ()
virtual void | TextureMappingTechnique (const int map)
virtual int | TextureMagnificationFilter ()
virtual void | TextureMagnificationFilter (const int filter)
virtual int | TextureMinificationFilter ()
virtual void | TextureMinificationFilter (const int filter)
virtual void | Translate (float tr[])
virtual void | Translate (float x, float y, float z)
virtual void | TranslateVertices (float x, float y, float z)
virtual void | UpdateBoundingVolume ()
void * | UserData () const
void | UserData (void *data)
virtual void | SetVertexColor (unsigned int vertex, unsigned char CurrentFillColor[])
virtual Vertex * | Vertices ()
virtual void | SetVertices (unsigned int nPoints, Vertex *vertices)
void | VaSetVertices (unsigned int nPoints,...)
int * | ViewMatrix ()
bool | Visible () const
bool | Visibility () const
virtual void | Visibility (const bool vis)
virtual Vector | WorldRotationPoint ()
virtual void | WorldRotationPoint (const Vector &vert)
virtual Vertex | WorldVertex (unsigned int i)
virtual void | WorldVertex (unsigned int i, const Vertex &vert)
bool | LogicalToWindow (const Vector &logical, Vector &winLoc, const OpenGLMatrices &alternateMatrices=OpenGLMatrices())
bool | WindowToLogical (const Vector &winLoc, Vector &logical, Vector *directionVector=NULL, const OpenGLMatrices &alternateMatrices=OpenGLMatrices())
void | LogicalToDCS (Vector logicalPoint, Vector &objectLocal, const Vector *directionVector, const Vector &planeNormal=Vector(0, 0, 1), const Vector &planePoint=Vector(), const GlsMatrixType *dcsMatrix=NULL)
void | DCSToLogical (Vector dcsPoint, Vector &logicalPoint, const GlsMatrixType *dcsMatrix=NULL)
bool | Create (GlsGloFile &dataStream, Group *parent)
void | GeometryRefresh ()
| Invalidates the painter and refreshes the geometry on the next paint cycle.
virtual bool | GetPlaneVectorPoints (Vertex &p1, Vertex &p2, Vertex &p3, Vertex &planeVector)
void | NotifyAttributeChanged (const AttributeName &name) override
virtual void | SetPainter (GlsPainter *painter)
virtual GlsPainter * | GetPainter ()
void | InvalidatePainter ()
virtual bool | IsVisibleInScene (const DisplayObject *obj=NULL) const
Public Member Functions inherited from AttributeChangedNotifier
virtual void | NotifyAttributeChanged (const AttributeName &name)=0
virtual | ~AttributeChangedNotifier ()
Public Member Functions inherited from WeakReferenceableMixin
void | AddWeakReference (WeakReference *weakRef) override
void | NotifyWeakReferenceDestroyed (WeakReference *ref) override
virtual void | AddWeakReference (WeakReference *weakRef)=0
virtual void | NotifyWeakReferenceDestroyed (WeakReference *weakReference)=0

## Static Public Attributes
static const Char_t | EOL
| Carriage return (end of line) character.

## Protected Types
typedef std::vector< CharAttr_t > | CharAttrCont_t
| Typedef for a list of character attributes.

## Protected Member Functions
char * | FormatVarArgList (const int initialBufferLength, const char *format, va_list args)
void | RecalcDirectionVectors ()
Protected Member Functions inherited from GLPolygon
void | DrawSolidGeometry (bool textureObject, bool gouraudShading, bool normal)
void | DrawOutlineGeometry ()
| Draws lines that form this polygon's outline.
void | DrawPoints ()
| Draws a point for each vertex of this polygon.
void | BakeVBO (bool hasT, bool hasC, bool hasN)
Protected Member Functions inherited from DisplayObject
virtual void | VaListSetVertices (unsigned int nPoints, va_list args)
virtual void | VaListSetNormals (unsigned int nPoints, va_list args)
virtual void | VaListSetTexCoords (unsigned int nPoints, va_list args)
void | ApplyTextureMinMagSettings ()
| Updates the state manager's texture minification and magnification filter based on this display's configuration.
void | ApplyTextureEnvModeSettings ()
| Updates the state manager's texture environment based on this object configuration.
bool | SetupTextureIsNeeded ()
virtual int | ColorMaterialMode ()
void | AllocateModelMatrix ()
bool | ApplyDynamicRotation ()
virtual void | CalcDrawMatrix ()
void | CalcDrawMatrixIfExists ()
virtual void | CalculateMatrices (const OpenGLMatrices &newMatrices)
bool | InsideVertexExtents (float x, float y, unsigned int nVerts, Vertex *verts, float tolerance)
void | LastDrawMatrixLocation (const Vertex &loc)
const Vertex & | LastDrawMatrixLocation ()
void | NeedCalculate (bool val)
void | PickSetup (float x, float y, float z, Vertex *vertices, unsigned int vertex_cnt, const Vector &directionVector)
void | PickCleanup (Vertex *vertices, unsigned int vertex_cnt)
virtual void | SetFromGloData (GlsGloFileAttribute &data)
virtual void | SetValue (int spec, va_list &args)
int | GetApplicableTextureIndex ()
int | GetApplicableTextureRepeat ()
Protected Member Functions inherited from WeakReferenceableMixin
| WeakReferenceableMixin ()
virtual | ~WeakReferenceableMixin ()

## Protected Attributes
float | _border
CharAttrCont_t | _chars
Vertex | _currentVertices [NUM_VERTICES]
| The corners of the text object.
float | _cellHeight
float | _cellWidth
bool | _constrainRatio
bool | _controlCellSize
GlsFontBase * | _font
bool | _halo
| Whether or not the halo effect is on.
GlsColor | _haloColor
Justify_t | _justify
float | _lineSpacing
bool | _lockCellSize
bool | _needToRebuild
bool | _shadow
| Whether or not the shadow effect is on.
GlsColor | _shadowColor
Vector | _shadowOffset
std::string | _text
bool | _uppercase
Vector | _vX
Vector | _vY
Vector | _vZ
bool | _wrapText
ScopedPtr< RuntimeGlyphGenerationText > | _runtimeGlyphGenerationText
Protected Attributes inherited from GLPolygon
GlsVertexArray | _vertArray
| A vertex array that makes up this mesh. Each vertex contains data such as position, normal, texture coordinates, and color.
bool | _pendingFillColor
| If true and gouraudShading is true during a paint cycle, then it'll bake the VBO.
Protected Attributes inherited from DisplayObject
bool | _geometryRefresh
| Whether or not the geometry (VBOs etc.) needs to be updated on the GPU.
int | _alphaMode
bool | _antiAlias
bool | _attributesAdded
bool | _blinking
float | _blinkRate
bool | _isBlinkedOff
| Stores whether the object is presently blinked on or off.
GlsColor | _color
bool | _cullBackFace
GlsMatrixType | _dcsMatrix
unsigned char | _depthTest
GlsMatrixType * | _drawMatrix
bool | _needCalcDrawMatrix
| True if CalcDrawMatrix() needs to be called on this object.
unsigned char | _lineStippleMultiplier
unsigned short | _lineStipplePattern
float | _lineWidth
Vertex | _location
DynamicArray< int > | _materialIndices
| List of materials associated with this object.
GlsMatrixType * | _modelMatrix
Vector * | _normals
unsigned int | _nTex_vertices
unsigned int | _nVertices
unsigned char | _polygonEnd
unsigned char | _polygonMode
GlsMatrixType * | _projMatrix
unsigned char | _shading
Vector * | _texCoord
GlsColor | _textureBlendColor
int | _textureIndex
unsigned char | _textureMagFilter
unsigned char | _textureMinFilter
unsigned char | _textureMap
Vector | _texturePoints [4]
unsigned char | _textureRepeat
void * | _userData
Vertex * | _vertices
int * | _viewMatrix
bool | _visible
IGlsStateManager * | _stateManager
| The state manager that interfaces with OpenGL and maintains its render state.
Protected Attributes inherited from WeakReferenceableMixin
DynamicArray< WeakReference * > * | _weakRefs

## Static Protected Attributes
static const Vector | XAXIS
| Vector for the global X axis.
static const Vector | YAXIS
| Vector for the global Y axis.
static Vertex | INITIAL_VERTICES [NUM_VERTICES]
| Default corners for new text objects.

## Additional Inherited Members
Static Public Member Functions inherited from GLPolygon
static DisplayObject * | CreateInstance ()
Static Public Member Functions inherited from DisplayObject
static void | UseManualBlinkElapsedTime (bool useManualTime)
static void | SetManualBlinkElapsedTime (double elapsedTime)

## Detailed Description

The GlsText class provides a base class for all GLStudio text components.

## Constructor & Destructor Documentation

## ◆ GlsText() [1/2]

GlsText | ( |  | ) |

Class Constructor.

## ◆ GlsText() [2/2]

GlsText | ( | const GlsText & | that,
|  | const bool | generateNames
| ) |  |

Copy constructor

Parameters

  that | The object to copy from.
  generateNames | Whether or not to generate an instance name for this object.

## ◆ ~GlsText()

virtual ~GlsText | ( |  | ) |
| virtual

Class Constructor.

## Member Function Documentation

## ◆ Baseline() [1/2]

float Baseline | ( |  | ) |

Returns
  The baseline shift for the first character.

## ◆ Baseline() [2/2]

void Baseline | ( | const float & | baselineShift | ) |

Sets the baseline shift for all characters.

Parameters

  baselineShift | multiplier used to shift the baseline. This will be multiplied by the character height to determine how much to shift. A value of 0 does not shift at all, a value of 1 will shift up by the height of 1 character.

## ◆ BgColor() [1/2]

GlsColor BgColor | ( |  | ) |

Returns
  The background color for the first character.

## ◆ BgColor() [2/2]

void BgColor | ( | const GlsColor & | color | ) |

Sets the background color for all characters

Parameters

  color | The background color to set

## ◆ Border() [1/2]

float Border | ( |  | ) | const
| inline

Returns
  The spacing between the box outline and the text in logical units.

## ◆ Border() [2/2]

void Border | ( | const float & | units | ) |

Sets the spacing between the box outline and the text in logical units.

Parameters

  units | Border offset value in logical units

## ◆ CellHeight() [1/2]

float CellHeight | ( |  | ) | const
| inline

Returns
  the height of a char cell of the grid in logical units.

## ◆ CellHeight() [2/2]

void CellHeight | ( | float | height | ) |

Sets the height of a character cell of the grid in logical units when stretch to fit mode is in effect. When stretch to fit mode is not in effect, this call will not affect the grid since the font determines the cell size.

Parameters

  height | the new character cell height.

## ◆ CellWidth() [1/2]

float CellWidth | ( |  | ) | const
| inline

Returns
  the width of a char cell of the grid in logical units.

## ◆ CellWidth() [2/2]

void CellWidth | ( | float | width | ) |

Sets the width of a character cell of the grid in logical units when stretch to fit mode is in effect. When stretch to fit mode is not in effect, this call will not affect the grid since the font determines the cell size.

Parameters

  width | the new character cell width.

## ◆ Char()

void Char | ( | Char_t | code | ) |

Sets the character code for all cell positions in the text grid

Parameters

  code | The Unicode character code to set

## ◆ CharAttr()

CharAttr_t CharAttr | ( | unsigned int | index | ) | const
| inline

Returns
  A particular cell's character attributes.

Parameters

  index | The index whose attributes are to be returned.

## ◆ CharAttribs()

CharAttr_t CharAttribs | ( |  | ) | const
| inline

Accessor method used by metadata to read and write the character attributes for this object. Currently only allows you to load and save attributes for the entire object, not on a per character basis.

Returns
  The character attribute for the first character in the object and therefore for every character in the object

## ◆ CharScaling() [1/2]

float CharScaling | ( |  | ) |

Returns
  The scale factor of the first character.

## ◆ CharScaling() [2/2]

void CharScaling | ( | const float & | newScale | ) |

Sets the scale factor of all characters NOTE: This is the size of the character in its cell not the overall scale of the entire object

Parameters

  newScale | The new scale factor of the characters (0.0 < newScale <= 1.0)

## ◆ CharSpacing() [1/2]

float CharSpacing | ( |  | ) |

Returns
  The horizontal character spacing for the first character.

## ◆ CharSpacing() [2/2]

void CharSpacing | ( | const float & | horizontalSpacing | ) |

Sets the horizontal character spacing for all characters (spacing from the start of one character to the start of the next character. 1.0 is the default spacing 2.0 would be twice the normal spacing

Parameters

  horizontalSpacing | The horizontalSpacing value

## ◆ ConstrainCellRatio() [1/2]

bool ConstrainCellRatio | ( |  | ) | const
| inline

Returns
  whether to constrain cell width and height proportions when in stretch to fit mode and changing the size of character cells.

## ◆ ConstrainCellRatio() [2/2]

void ConstrainCellRatio | ( | bool | constrain | ) |

Sets whether to constrain cell width and height proportions when in stretch to fit mode and changing the size of character cells.

Parameters

  constrain | true to constrain proportions.

## ◆ ControlCellSize() [1/2]

bool ControlCellSize | ( |  | ) | const
| inline

Returns
  whether or not the character cell size will stretch to fit this object's bounding box or if it is based on its font and font

## ◆ ControlCellSize() [2/2]

void ControlCellSize | ( | bool | control | ) |

Sets whether or not the character cell size will stretch to fit this object's bounding box or if it is based on its font and font.

Parameters

  control | True if stretch to fit will be enabled

## ◆ CopyGeometry()

virtual void CopyGeometry | ( | DisplayObject * | src | ) |
| override virtual

Copies the geometry information from one object to another. Used by the undo mechanism to allow user to undo a geometry change.

Parameters

  src | The object to copy geometry from

Reimplemented from DisplayObject.

Reimplemented in GlsCTLTextBox, GlsTextBox, and GlsTextGrid.

## ◆ CopyProperties()

virtual void CopyProperties | ( | DisplayObject * | src | ) |
| override virtual

Copies the attributes except for geometry attributes from one object to another. Used by the undo mechanism to undo most attribute change operations.

Parameters

  src | The object to copy properties from

Reimplemented from DisplayObject.

Reimplemented in GlsCTLTextBox, GlsTextBox, and GlsTextGrid.

## ◆ Erase()

void Erase | ( |  | ) |

Erase all characters.

## ◆ FauxBold() [1/2]

bool FauxBold | ( |  | ) |

Returns
  The bold state on or off for the first character.

## ◆ FauxBold() [2/2]

void FauxBold | ( | const bool & | bold | ) |

Set the bold state on or off for all characters

Parameters

  bold | Bold state

## ◆ Font() [1/2]

GlsFontBase * Font | ( |  | ) | const
| inline

Returns
  The font currently being used to render this text.

## ◆ Font() [2/2]

void Font | ( | GlsFontBase * | font | ) |

Set the font used to render this text.

Parameters

  font | Pointer to a font instance to set

## ◆ FormatVarArgList()

char * FormatVarArgList | ( | const int | initialBufferLength,
|  | const char * | format,
|  | va_list | args
| ) |  |
| protected

Allocate a text buffer of the appropriate size for this grid and output snprintf style format into the buffer

Parameters

  format | snprintf style format spec
  args | arguments for sprintf style formatting
  initialBufferLength | the length of the initial character buffer

Returns
  formatted textbuffer ( must be deleted by caller )

## ◆ Halo() [1/2]

bool Halo | ( |  | ) | const
| inline

Returns
  Whether or not the halo is visible.

## ◆ Halo() [2/2]

void Halo | ( | bool | halo | ) |

Set the halo state to on or off for the text

Parameters

  halo | halo state

## ◆ HaloColor() [1/2]

GlsColor HaloColor | ( |  | ) | const
| inline

Returns
  The current halo color.

## ◆ HaloColor() [2/2]

void HaloColor | ( | const GlsColor & | color | ) |

Set the color of the halo around the text

Parameters

  color | halo color

## ◆ InvalidateFont()

void InvalidateFont | ( |  | ) |

Invalidates the font for this object. If the font is invalidated, this object will draw using the default font. This is used in the editor and should not need to be called by any user code at run-time.

## ◆ Inverse() [1/2]

bool Inverse | ( |  | ) |

Returns
  The inverse video state on or off for the first character.

## ◆ Inverse() [2/2]

void Inverse | ( | const bool & | inverse | ) |

Set the inverse video state on or off for all characters

Parameters

  inverse | inverse video state

## ◆ Justify() [1/2]

Justify_t Justify | ( |  | ) | const
| inline

Returns
  the justification mode (LEFT, RIGHT, CENTER)

## ◆ Justify() [2/2]

void Justify | ( | Justify_t | justification | ) |

Set the justification mode for this text object

Parameters

  justification | The justification mode (LEFT, RIGHT, CENTER)

## ◆ LineSpacing() [1/2]

float LineSpacing | ( |  | ) | const
| inline

Returns
  the linespacing for the text object.

## ◆ LineSpacing() [2/2]

void LineSpacing | ( | float | spacing | ) |

Sets the linespacing for the text object. A line spacing of 1.0 indicates normal "single spaced" text. 2.0 would be double spaced, etc.

Parameters

  spacing | The new linespacing value

## ◆ LockCellSize() [1/2]

bool LockCellSize | ( |  | ) | const
| inline

Returns
  the setting of lock cell size.

## ◆ LockCellSize() [2/2]

void LockCellSize | ( | bool | lock | ) |

Sets whether or not the cell size is locked while in stretch to fit mode. If locked, changing other attributes will not affect the cell size, but the box size instead. If not locked, changing certain attributes, eg. border, will affect the cell size.

Parameters

  lock | true to lock cell size, false otherwise

## ◆ RecalcDirectionVectors()

void RecalcDirectionVectors | ( |  | ) |
| protected

Calculates direction vectors based on the orientation of its vertices.

Note
  Not normally called by users.

## ◆ RequiresFontFile()

virtual bool RequiresFontFile | ( |  | ) | const
| inline virtual

Returns
  Whether or not this text object requires a font file to work.. If this returns true, the text object may not work with the generated ASCII / UNICODE font types.

Reimplemented in GlsCTLTextBox.

## ◆ Rotate() [1/4]

virtual void Rotate | ( | const Vector & | orig,
|  | float | angle,
|  | const Vector & | axis
| ) |  |
| virtual

Rotates the object (around the specified axis) by the angle indicated, at the point specified. Recalculates the vertex data.

Parameters

  orig | The point to rotate around
  angle | The angle to rotate by, in degrees
  axis | The arbitrary axis to rotate the object around

Reimplemented from DisplayObject.

## ◆ Rotate() [2/4]

virtual void Rotate | ( | const Vector & | orig,
|  | float | angle,
|  | const Vector & | axis
| ) |  |
| override virtual

Rotates the object (around the specified axis) by the angle indicated, at the point specified. Recalculates the vertex data.

Parameters

  orig | The point to rotate around
  angle | The angle to rotate by, in degrees
  axis | The arbitrary axis to rotate the object around

Reimplemented from DisplayObject.

## ◆ Rotate() [3/4]

virtual void Rotate | ( | const Vector & | origin,
|  | float | angle,
|  | int | axis = `Z_AXIS`
| ) |  |
| virtual

Rotates the object (around the specified axis) by the angle indicated, at the point specified. Recalculates the vertex data.

Parameters

  origin | The point to rotate around
  angle | The angle to rotate by, in degrees
  axis | The axis to rotate the object around

Reimplemented from DisplayObject.

## ◆ Rotate() [4/4]

virtual void Rotate | ( | float | angle,
|  | int | axis = `Z_AXIS`
| ) |  |
| virtual

Rotates the object (around the specified axis) by the angle indicated, at the object's rotation point. Recalculates the vertex data.

Parameters

  angle | The angle to rotate by, in degrees
  axis | The axis to rotate the object around.

Reimplemented from DisplayObject.

## ◆ SetAvailableAttributes()

virtual void SetAvailableAttributes | ( | unsigned int | value | ) |
| override virtual

Specifies which attributes are available for the object. Currently the available attributes cannot be changed after they have been set. (Only the first call has an effect.)

Parameters

  value | A bitfield specifying which types of attributes to make available.

See also
  AvailableAttributesEnum

Reimplemented from DisplayObject.

Reimplemented in GlsCTLTextBox, GlsTextBox, and GlsTextGrid.

## ◆ SetFromGloData()

virtual void SetFromGloData | ( | GlsGloFileAttribute & | data | ) |
| override virtual

Set a single attribute from the GLO file.

Parameters

  data | The attribute to set and its associated data.

Reimplemented from DisplayObject.

Reimplemented in GlsCTLTextBox, GlsTextBox, and GlsTextGrid.

## ◆ SetRebuild()

void SetRebuild | ( |  | ) |
| inline

Sets the rebuild flag, which forces the text object to rebuild itself on the next call to Calculate, PreDraw, or Draw.

## ◆ SetValue()

virtual void SetValue | ( | int | spec,
|  | va_list & | args
| ) |  |
| override virtual

Sets an attribute of this object using variable arguments

Parameters

  spec | A GLS_Initializer tag
  args | A variable argument list

Reimplemented from DisplayObject.

Reimplemented in GlsTextGrid.

## ◆ Shadow() [1/2]

bool Shadow | ( |  | ) | const
| inline

Returns
  Whether or not text shadow is visible.

## ◆ Shadow() [2/2]

void Shadow | ( | bool | shadow | ) |

Set the shadow state to on or off for the text

Parameters

  shadow | shadow state

## ◆ ShadowColor() [1/2]

GlsColor ShadowColor | ( |  | ) | const
| inline

Returns
  The current shadow color.

## ◆ ShadowColor() [2/2]

void ShadowColor | ( | const GlsColor & | color | ) |

Set the color of the shadow behind the text

Parameters

  color | shadow color

## ◆ ShadowDistance()

void ShadowDistance | ( | const float & | dist | ) |
| inline

Set the distance of the shadow from the text. Distance represent a percentage of the character width. Negative values are up and to the left. Positive values are down and to the right. Note that the corresponding getter was removed because ShadowDistance is deprecated in favor of ShadowOffset.

Parameters

  dist | shadow distance

## ◆ ShadowOffset() [1/2]

Vector ShadowOffset | ( |  | ) |
| inline

Returns
  The current shadow offset.

## ◆ ShadowOffset() [2/2]

void ShadowOffset | ( | const Vector & | offset | ) |

Set the Cartesian offset of the shadow from the text. Offset represent a percentage of the character width. Negative values are down and to the left. Positive values are up and to the right. Z component is ignored.

Parameters

  offset | shadow offset

## ◆ StrikeThru() [1/2]

bool StrikeThru | ( |  | ) |

Returns
  The strikethru state for the first character.

## ◆ StrikeThru() [2/2]

void StrikeThru | ( | const bool & | strike | ) |

Sets the strikethru state for all characters

Parameters

  strike | Whether or not set strikethru

## ◆ String() [1/3]

std::string String | ( |  | ) | const
| inline

Returns
  The string currently stored in this object. NOTE: This can contain extra characters not being displayed in the grid if the string size is greater than will fit within the grid.

## ◆ String() [2/3]

virtual void String | ( | const char * | s | ) |
| inline virtual

Sets the Unicode string to be displayed for this object

Parameters

  s | C Style string

## ◆ String() [3/3]

virtual void String | ( | const std::string & | s | ) |
| virtual

Sets the Unicode string to be displayed for this object

Parameters

  s | STD Template Library String

## ◆ TextColor() [1/2]

GlsColor TextColor | ( |  | ) |

Returns
  The foreground color for the first character in the text grid.

## ◆ TextColor() [2/2]

void TextColor | ( | const GlsColor & | color | ) |

Sets the foreground color for all characters in the text grid.

Parameters

  color | The foreground color to set

## ◆ Underline() [1/2]

bool Underline | ( |  | ) |

Returns
  The on/off state of underline for the first character.

## ◆ Underline() [2/2]

void Underline | ( | const bool & | underline | ) |

Turns on/off underlines for all characters

Parameters

  underline | Whether or not to enable underline

## ◆ Uppercase() [1/2]

bool Uppercase | ( |  | ) | const
| inline

Returns
  The current uppercase state.

## ◆ Uppercase() [2/2]

void Uppercase | ( | bool | uppercase | ) |

Makes all characters uppercase when rendered.

Parameters

  uppercase | Whether or not to enable uppercase

## ◆ WrapText() [1/2]

bool WrapText | ( |  | ) | const
| inline

Returns
  current word wrap behavior for this object

## ◆ WrapText() [2/2]

void WrapText | ( | bool | wrap | ) |

Enable/disable word wrap behavior for this object

Parameters

  wrap | Whether or not to enable word wrap

## Member Data Documentation

## ◆ _border

float _border
| protected

The border offset in logical units for this object. Defines the size of the empty space between the outline of the box and its text

## ◆ _cellHeight

float _cellHeight
| protected

Height of each character cell in the grid in logical units

## ◆ _cellWidth

float _cellWidth
| protected

Width of each character cell in the grid in logical units

## ◆ _chars

CharAttrCont_t _chars
| protected

Container of character attributes

## ◆ _constrainRatio

bool _constrainRatio
| protected

Only effective when _controlCellSize is true. Whether or not to constrain cell size ratio when changing cell height or width.

## ◆ _controlCellSize

bool _controlCellSize
| protected

If true, font size does not control cell size

## ◆ _font

GlsFontBase* _font
| protected

Current font being used for the text

## ◆ _haloColor

GlsColor _haloColor
| protected

Color of the halo effect behind the characters

## ◆ _justify

Justify_t _justify
| protected

Justification setting (LEFT, RIGHT, CENTER)

## ◆ _lineSpacing

float _lineSpacing
| protected

Line spacing between grid rows as a percentage

## ◆ _lockCellSize

bool _lockCellSize
| protected

Only effective when _controlCellSize is true. If true, changes to rows, columns, border, line spacing, column spacing, etc. will not change the cell size. Normally, when _controlCellSize is true these attributes affect the cell size.

## ◆ _needToRebuild

bool _needToRebuild
| protected

This is set to true whenever an attribute changes that will affect the size of the grid or its cells.

## ◆ _runtimeGlyphGenerationText

ScopedPtr<RuntimeGlyphGenerationText> _runtimeGlyphGenerationText
| protected

Pointer to the internal data needed for runtime glyph generation.

## ◆ _shadowColor

GlsColor _shadowColor
| protected

Color of the shadow effect behind the characters

## ◆ _shadowOffset

Vector _shadowOffset
| protected

Offset of the shadow effect from the characters. Z component is ignored.

## ◆ _text

std::string _text
| protected

String of text to be displayed.

## ◆ _uppercase

bool _uppercase
| protected

If true, all characters will be displayed in uppercase

## ◆ _vX

Vector _vX
| protected

Direction vector indicating direction of horizontal travel for rendering

## ◆ _vY

Vector _vY
| protected

Direction vector indicating direction of vertical travel for rendering

## ◆ _vZ

Vector _vZ
| protected

Normal to the Vx Vy plane

## ◆ _wrapText

bool _wrapText
| protected

Whether or not to word wrap text

The documentation for this class was generated from the following file:

- gls_text.h